unit fonctions_aforms;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms;

{$IFDEF VERSIONS}
  const
    gVer_fonctions_aforms : T_Version = (  Component : 'Gestion de Fenêtres' ;
                                       FileUnit : 'fonctions_aforms' ;
                                       Owner : 'Matthieu Giroux' ;
                                       Comment : 'Fonctions centralisées adaptatives de fiches.' ;
                                       BugsStory :  '1.0.0.0 : SuperForm and ScaleForm out of Extended.';
                                       UnitType : 3 ;
                                       Major : 1 ; Minor : 0 ; Release : 0 ; Build : 0 );

{$ENDIF}

function ffor_CreateForm ( const afor_FormClasse : TFormClass ) : TCustomForm;
function ffor_CreateUniqueChild ( afor_FormClasse : TFormClass; const newFormStyle : TFormStyle; const ab_Ajuster : Boolean = True ; const aico_Icon : TIcon = nil): TCustomForm;

implementation

uses U_FormAdapt, fonctions_scaledpi,
     fonctions_proprietes, fonctions_forms;

function ffor_CreateForm ( const afor_FormClasse : TFormClass ) : TCustomForm;
Begin
  Application.CreateForm ( afor_FormClasse, Result );
  if not ( Result is TF_FormAdapt ) Then
   Begin
    ScaleFormCreate(Result,GetApplicationScale);
    ScaleFormShow  (Result,GetApplicationScale);
   end;
end;


// Création d'une form MDI renvoie True si la form existe dans les enfants MDI
// as_FormNom        : nom      de la form
// afor_FormClasse   : classe   de la form
// afor_Reference    : variable de la form
// newFormStyle      : style    de la form à mettre
function ffor_CreateUniqueChild ( afor_FormClasse : TFormClass; const newFormStyle : TFormStyle; const ab_Ajuster : Boolean = True ; const aico_Icon : TIcon = nil): TCustomForm;
var
  li_i : integer;
  lico_icon : Ticon ;
begin
  Result := nil ;
    // Recherche sûre de fiches quelconques
  For li_i := Application.ComponentCount - 1 downto 0
   do if (  Application.Components [ li_i ] is TCustomForm )
     and (( Application.Components [ li_i ] as TCustomForm ).ClassType = afor_FormClasse )
    Then
      Begin
        Result := TCustomForm ( Application.Components [ li_i ]);
      End ;

      //Création si nil
  if ( Result = nil )
    Then
      Result := ffor_CreateForm ( afor_FormClasse );
  If  assigned ( aico_Icon      )
  and assigned ( Result )
  and (fobj_getComponentObjectProperty ( Result, 'Icon' ) is TIcon )
   Then
    Begin
      lico_icon := TIcon ( fobj_getComponentObjectProperty ( Result, 'Icon' ));
      if assigned ( lico_icon ) then
        Begin
          lico_icon.Modified := False ;
          lico_icon.PaletteModified := False ;
          if lico_icon.Handle <> 0 Then
            Begin
              lico_icon.ReleaseHandle ;
              lico_icon.CleanupInstance ;
            End ;
          lico_icon.Handle := 0 ;
          lico_icon.Assign ( aico_Icon );
          lico_icon.Modified := True ;
          lico_icon.PaletteModified := True ;

          Result.Invalidate ;

        End;
    End ;
    // Mise à jour de la form
  if Assigned(Result)
  and ab_Ajuster
  and ( Result is TCustomForm ) then
    fb_setNewFormStyle ( Result as TCustomForm , newFormStyle, ab_Ajuster );
end;

{$IFDEF VERSIONS}
initialization
  p_ConcatVersion ( gVer_fonctions_aforms );
{$ENDIF}
end.

